#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "rs232_dll.h"
#include "comchk.h"

void more_(void);
void packet_process(unsigned char *packet,int len);

int main (void)
{
	int i,n,st;
	int myport,baud;
	unsigned char c,c_bak,d;
	unsigned char buf[80];
	unsigned char packet[80];
	int packet_pos,packet_len,packet_state,sum;
	
	printf("MindFlex Test by E.Kako \n");
	
	port_device_scan(); port_device_pickup("FTDIBUS");
	n=get_how_many_port_devices();
	if (n==0) { printf("|[g܂\n",buf); more_(); exit(1); }
	
	myport=get_port_number(0);
	baud=9600;
	printf("Port=%d , Baud=%d\n",myport,baud);
	
	st=rs_open(myport,baud);
	if (st==-1) { printf("COM%i|[g݂ȂAɎgpł\n",myport); more_(); exit(1); }
	
	c=0; c_bak=0; packet_pos=0; packet_state=0;
	while (1) {
		if (kbhit()) {
			if (getch()==0x1B) { rs_close(myport); exit(0); }
		}
		if (rs_size(myport)) {
			c_bak=c; c=rs_getch(myport);
			if (packet_state==0) {
				if ((c==0xAA)&&(c_bak==0xAA)) {
					packet_pos=0; sum=0; packet_state=1;
				}
			} else if (packet_state==1) {
				packet_len=c;
				if (packet_len>32 /* max length */ ) {
					printf("packet length error\n"); packet_state=0;
				}
				packet_state=2;
			} else if (packet_state==2) {
				packet[packet_pos]=c; sum+=c; packet_pos++;
				if (packet_pos>packet_len) {
					sum= sum % 256;
					if (sum==0xFF) {
						packet_process(packet,packet_len); /* do packet process */
					} else {
						printf("packet checksum error\n");
					}
					packet_state=0;
				}
			}
		}
	}
    return 0;
}

void more_(void)
{
	printf("[Push Enter Key]\n"); getch();
}

void packet_process(unsigned char *packet,int len)
{
	int i,j,k;
	int quality,attention,meditation;
	int part_len;
	int packet_error;
	int power[8];
	
	packet_error=0; quality= -1; attention= -1; meditation= -1;
	for (i=0;i<8;i++) { power[i]=-1; }
	for (i=0;i<len;i++) {
		if (packet[i]==0x02) {
			quality=packet[++i];
			continue;
		} else if (packet[i]==0x83) {
			part_len=packet[++i];
			if (part_len>24) {
				printf("part_len error (part_len=%d)\n",part_len);
			} else {
				k=0;
				for (j=0;j<part_len;j+=3) {
					power[k++]=(int)packet[i+j+1]*65536 + (int)packet[i+j+2]*256 + (int)packet[i+j+3];
				}
			}
			i+= part_len;
			continue;
		} else if (packet[i]==0x04) {
			attention=packet[++i];
			continue;
		} else if (packet[i]==0x05) {
			meditation=packet[++i];
			continue;
		} else {
			packet_error=1;
			printf("packet error\n");
		}
	}
	
	if (packet_error==0) {
		printf("--- MindFlex data received. ---\n");
		
		printf(" Quality:%d\n",quality);
		printf(" Attention:%d\n",attention);
		printf(" Meditation:%d\n",meditation);
		
		printf(" Delta wave:%d\n",power[0]);
		printf(" Theta wave:%d\n",power[1]);
		printf(" Low  Alpha wave:%d\n",power[2]);
		printf(" High Alpha wave:%d\n",power[3]);
		printf(" Low  Beta  wave:%d\n",power[4]);
		printf(" High Beta  wave:%d\n",power[5]);
		printf(" Low  Gamma wave:%d\n",power[6]);
		printf(" Mid  Gamma wave:%d\n",power[7]);
	}
}
